//+------------------------------------------------------------------+
//|                                               -.mq4 |
//+------------------------------------------------------------------+
#property copyright "fion"
#property link      ""
#include <stdlib.mqh>

extern int    TrailingPend    =    15; //        
//+------------------------------------------------------------------+
int MinStop,Order_Ticket,Order_Magic; 
//+------------------------------------------------------------------+ 
void init() 
  { 
   MinStop=MarketInfo(Symbol(),MODE_STOPLEVEL); 
   Print(" : "+MinStop); 
  } 
//+------------------------------------------------------------------+ 
void start()
{
   if (IsTradeAllowed()==false) return(0);              //  
//      
      for(int i=OrdersTotal()-1;i>=0;i--){
       if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
       if (OrderSymbol()!=Symbol()) continue; 
       if (OrderType()==OP_SELL && OrderMagicNumber()==0)
          {double lot=OrderLots(); Order_Ticket=OrderTicket();
           if(BuyStop(Order_Ticket)==0)
              SetBuyStop(Order_Ticket,lot,Ask+TrailingPend*Point,0,0);} 
      
       if (OrderType()==OP_BUY && OrderMagicNumber()==0)
          {lot=OrderLots(); Order_Ticket=OrderTicket();
           if(SellStop(Order_Ticket)==0)
              SetSellStop(Order_Ticket,lot,Bid-TrailingPend*Point,0,0);} 
          }  
//    (    )    
      for( i=OrdersTotal()-1;i>=0;i--){
       if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
       if (OrderSymbol()!=Symbol()) continue; 
       if (OrderType()==OP_SELLSTOP)
          {Order_Magic=OrderMagicNumber();Order_Ticket=OrderTicket();
           if(Open_Buy(Order_Magic)==0)    OrderDelete(Order_Ticket);}
      
       if (OrderType()==OP_BUYSTOP)
          {Order_Magic=OrderMagicNumber();Order_Ticket=OrderTicket();
           if(Open_Sell(Order_Magic)==0)    OrderDelete(Order_Ticket);}
          } 
       
//+--------+ 

  return(0);
}

//+------------------------------------------------------------------+  
int SetBuyStop(int MAGIC,double lots ,double Price, double Loss,double Profit) 
   {
   while (!IsTradeAllowed()) Sleep(5000);
   RefreshRates();
   int minstop=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double price=NormalizeDouble(Price,Digits);
   double loss=0;  if (Loss>0 && price-Loss>minstop*Point)  loss=NormalizeDouble(Loss,Digits); 
   double profit=0; if (Profit>0 && Profit-price>minstop*Point) profit=NormalizeDouble(Profit,Digits);
   int ticket=OrderSend(Symbol(),OP_BUYSTOP,lots,price,5,loss,profit,"",MAGIC,0,Green); 
   if (ticket<1) Print("Set a pending order failed with error #",GetLastError());
   return(ticket);
   } 

int SetSellStop(int MAGIC,double lots, double Price, double Loss,double Profit) 
   {
   while (!IsTradeAllowed()) Sleep(5000);
   RefreshRates();
   int minstop=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double price=NormalizeDouble(Price,Digits);
   double loss=0;  if (Loss>0 && Loss-price>minstop*Point)  loss=NormalizeDouble(Loss,Digits); 
   double profit=0; if (Profit>0 && price-Profit>minstop*Point) profit=NormalizeDouble(Profit,Digits);
   int ticket=OrderSend(Symbol(),OP_SELLSTOP,lots,price,5,loss,profit,"",MAGIC,0,Gray); 
   if (ticket<1) Print("Set a pending order failed with error #",GetLastError()); 
return(ticket);
   } 
//+-----------------  ---------------------------------+
int BuyStop(int MAGIC){int cnt=0;for (int i=OrdersTotal()-1;i>=0;i--){// 
       if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
       if (OrderSymbol()!=Symbol()) continue; 
       if (OrderType()==OP_BUYSTOP && OrderMagicNumber()==MAGIC)cnt++;}return(cnt);}
//+------------------------------------------------------------------+
int SellStop(int MAGIC){int cnt=0;for (int i=OrdersTotal()-1;i>=0;i--){// 
       if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
       if (OrderSymbol()!=Symbol()) continue; 
       if (OrderType()==OP_SELLSTOP && OrderMagicNumber()==MAGIC)cnt++;}return(cnt);}
//+------------------------------------------------------------------+
int Open_Buy(int ticket){int count=0;for (int i=0; i<OrdersTotal(); i++){ 
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
      if (OrderSymbol()!=Symbol()) continue; 
      if (OrderType()==OP_BUY && OrderTicket()==ticket) count++;}return (count);} 
//+------------------------------------------------------------------+
int Open_Sell(int ticket){int count=0;for (int i=0; i<OrdersTotal(); i++){ 
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break; 
      if (OrderSymbol()!=Symbol()) continue; 
      if (OrderType()==OP_SELL && OrderTicket()==ticket) count++;}return (count);}
//+------------------------------------------------------------------+


                         